use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'FileStreamDemo')
	DROP DATABASE FileStreamDemo
GO
exec sp_filestream_configure @enable_level=1
GO
CREATE DATABASE FileStreamDemo
ON (
	NAME = 'FileStreamDemo_Data', 
	FileName = 'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\DATA\FileStreamDemo_Data.mdf',
	SIZE=10MB,
	FILEGROWTH=10MB),
FILEGROUP FileStreamData CONTAINS FILESTREAM DEFAULT (
	NAME = 'FileStreamData_Data',
	FILENAME = 'C:\FileStreamDemo\Files')
LOG ON (
	NAME = 'FileStreamData_Log',
	FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL10.MSSQLSERVER\MSSQL\DATA\FileStreamDemo_Log.ldf',
	SIZE=10MB,
	FILEGROWTH=10MB)
GO
use FileStreamDemo
GO
CREATE TABLE BlobData
(BlobID int NOT NULL IDENTITY(1,1),
BlogGUID uniqueidentifier ROWGUIDCOL  NOT NULL UNIQUE DEFAULT (NEWID()),
BlobValue varbinary(max) FILESTREAM) FILESTREAM_ON FileStreamData
GO
SELECT *
FROM BlobData 
GO
SELECT *
FROM sys.columns
WHERE object_id = object_id('BlobData')
GO
INSERT INTO BlobData
(BlobValue)
SELECT *
FROM OPENROWSET (BULK 'C:\FileStreamDemo\SampleFile.doc', SINGLE_BLOB) a
GO
SELECT *
FROM BlobData