/*New Data Types*/
/*Date*/
DECLARE @dt AS DATE
set @dt = GETDATE()
SELECT @dt
GO
/*Time*/
DECLARE @tm as TIME
DECLARE @tm1 as TIME(1)
DECLARE @tm3 as TIME(3)
SET @tm = GETDATE()
set @tm1 = GETDATE()
set @tm3 = GETDATE()
SELECT @tm, @tm1, @tm3
GO
/*datetime2*/
DECLARE @dt as datetime2
set @dt = GETDATE()
select @dt
GO
/*datetimeoffset*/
DECLARE @dt as datetimeoffset
SET @dt = '1/1/2008 1:12:34 +7:00'
select @dt
GO
/*hierarchyid*/
IF EXISTS (SELECT * FROM sys.tables WHERE name = 'Organization')
	DROP TABLE Organization
GO
CREATE TABLE Organization
   (
 NodeLevel hierarchyid,
    EmployeeID int,
    OrgLevel as NodeLevel.GetLevel(), 
    EmployeeName nvarchar(50) NOT NULL
   ) ;
GO
insert into Organization
(NodeLevel, EmployeeID,  EmployeeName)
values
(hierarchyid::GetRoot(),0,  'Bob')
go
Declare @Manager hierarchyid
SELECT @Manager = hierarchyid::GetRoot()
FROM Organization ;

insert into Organization
(NodeLevel, EmployeeId,  EmployeeName)
values
(@Manager.GetDescendant(null, null), 1, 'Joe')
go
Declare @Manager hierarchyid
declare @NodeLevel hierarchyid

select @NodeLevel = NodeLevel 
from Organization 
where EmployeeName = 'Joe'

SELECT @Manager = max(NodeLevel)
FROM Organization
where NodeLevel.GetAncestor(1) = @NodeLevel

insert into Organization
(NodeLevel, EmployeeID,  EmployeeName)
values
(@NodeLevel.GetDescendant(@Manager, null),2,  'Sarah')
go
select NodeLevel.ToString()as NodeLevel_String, *
FROM Organization
go

/*Geometry*/
IF EXISTS (SELECT * FROM sys.tables WHERE name = 'SpatialTable')
    DROP TABLE dbo.SpatialTable;
GO

CREATE TABLE SpatialTable 
    ( id int IDENTITY (1,1),
    GeomCol1 geometry, 
    GeomCol2 AS GeomCol1.STAsText() );
GO

INSERT INTO SpatialTable (GeomCol1)
VALUES (geometry::STGeomFromText('LINESTRING (100 100, 20 180, 180 180)', 0));

INSERT INTO SpatialTable (GeomCol1)
VALUES (geometry::STGeomFromText('POLYGON ((0 0, 150 0, 150 150, 0 150, 0 0))', 0));
GO

DECLARE @geom1 geometry;
DECLARE @geom2 geometry;
DECLARE @result geometry;

SELECT @geom1 = GeomCol1 FROM SpatialTable WHERE id = 1;
SELECT @geom2 = GeomCol1 FROM SpatialTable WHERE id = 2;
SELECT @result = @geom1.STIntersection(@geom2);
SELECT @result.STAsText();

/*Geography*/

IF EXISTS (SELECT * FROM sys.tables WHERE name = 'SpatialTable')
    DROP TABLE dbo.SpatialTable;
GO

CREATE TABLE SpatialTable 
    ( id int IDENTITY (1,1),
    GeogCol1 geography, 
    GeogCol2 AS GeogCol1.STAsText() );
GO

INSERT INTO SpatialTable (GeogCol1)
VALUES (geography::STGeomFromText('LINESTRING(47.656 -122.360, 47.656 -122.343)', 4326));

INSERT INTO SpatialTable (GeogCol1)
VALUES (geography::STGeomFromText('POLYGON((47.653 -122.358, 47.649 -122.348, 47.658 -122.348, 47.658 -122.358, 47.653 -122.358))', 4326));
GO
/*Where these lines intersect*/
DECLARE @geog1 as geography;
DECLARE @geog2 as geography;
DECLARE @result as geography;

SELECT @geog1 = GeogCol1 FROM SpatialTable WHERE id = 1;
SELECT @geog2 = GeogCol1 FROM SpatialTable WHERE id = 2;
SELECT @result = @geog1.STIntersection(@geog2);
SELECT @result.STAsText();
GO