USE master
GO
ALTER DATABASE AdventureWorks
SET CHANGE_TRACKING = ON
(CHANGE_RETENTION = 2 DAYS, AUTO_CLEANUP = ON)
GO
USE AdventureWorks
GO
ALTER TABLE Person.Contact
ENABLE CHANGE_TRACKING
WITH (TRACK_COLUMNS_UPDATED = ON)
GO

SELECT *
FROM sys.change_tracking_tables

SELECT *
FROM sys.change_tracking_databases 

UPDATE Person.Contact
	set LastName = 'Black'
where ContactId = 2

GO
DECLARE @Version BIGINT
SET @Version = CHANGE_TRACKING_CURRENT_VERSION();
SELECT *
FROM CHANGETABLE( CHANGES Person.Contact , @Version) a
GO
select A.*, B.*
from Person.Contact b
CROSS APPLY CHANGETABLE 
    (VERSION Person.Contact, (ContactId), (b.ContactId)) a
GO
